package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.GrupoCategoriaDAO;
import com.rjconsultores.ventaboletos.entidad.GrupoCategoria;

@SuppressWarnings("unchecked")
@Repository("grupoCategoriaDAO")
public class GrupoCategoriaHibernateDAO extends GenericHibernateDAO<GrupoCategoria, Integer>
		implements GrupoCategoriaDAO {

	@Autowired
	public GrupoCategoriaHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
		setSessionFactory(factory);
	}

	@Override
	public List<GrupoCategoria> obtenerTodos() {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
		return c.list();
	}

	@Override
	public List<GrupoCategoria> buscar(String descricao) {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
		c.add(Restrictions.eq("descGrupo", descricao));
		
		return c.list();
	}
}
